import 'package:flutter/foundation.dart';
import 'package:shared_preferences/shared_preferences.dart';

import 'package:plotter/utils/tools.dart';

class Data extends ChangeNotifier {
  // Application settings
  String _apiHost = '';
  String _apiStatus = '';

  String defaultApiHost = '127.0.0.1';

  String getParameterValue(String parameterCode) {
    switch (parameterCode) {
      case 'apiHost':
        {
          return _apiHost;
        }
    }

    return '';
  }

  setParameterValue(String parameterCode, String parameterValue) async {
    printlog('set parameter "$parameterCode" to value "$parameterValue"');
    switch (parameterCode) {
      case 'apiHost':
        {
          updateApiHost(parameterValue);
        }
        break;
    }
    final prefs = await SharedPreferences.getInstance();
    prefs.setString(parameterCode, parameterValue);
  }

  void initParametersValues() async {
    final prefs = await SharedPreferences.getInstance();
    setParameterValue('apiHost', prefs.getString('apiHost') ?? defaultApiHost);
  }

  String get apiHost => _apiHost;
  void updateApiHost(String apiHost) {
    _apiHost = apiHost;
    notifyListeners();
  }

  String get apiStatus => _apiStatus;
  void updateApiStatus(String apiStatus) {
    printlog('new API status: $apiStatus');
    _apiStatus = apiStatus;
    notifyListeners();
  }
}
